using System;
using System.Data;
using System.Collections.Generic;
using RMYY_CallCenter_Api.Utility;

namespace RMYY_CallCenter_Api.Bll
{
    /// <summary>
    /// T_Sys_UserAccount
    /// </summary>
    public partial class T_Sys_UserAccount
    {
        private readonly Dal.T_Sys_UserAccount dal = new Dal.T_Sys_UserAccount();
        public T_Sys_UserAccount()
        { }
        #region  BasicMethod

        /// <summary>
        /// 是否存在该记录
        /// </summary>
        public bool Exists(string F_UserCode)
        {
            return dal.Exists(F_UserCode);
        }

        /// <summary>
        /// 增加一条数据
        /// </summary>
        public int Add(Model.T_Sys_UserAccount model)
        {
            return dal.Add(model);
        }

        /// <summary>
        /// 更新一条数据
        /// </summary>
        public bool Update(Model.T_Sys_UserAccount model)
        {
            CacheHelper.Remove("User_" + model.F_UserCode);
            return dal.Update(model);
        }

        /// <summary>
        /// 删除一条数据
        /// </summary>
        public bool Delete(int F_UserId)
        {
            CacheHelper.RemoveContain("User_");
            return dal.Delete(F_UserId);
        }
        /// <summary>
        /// 删除一条数据
        /// </summary>
        public bool DeleteList(string F_UserIdlist)
        {
            CacheHelper.RemoveContain("User_");
            return dal.DeleteList(F_UserIdlist);
        }

        public bool DeleteFlagList(string F_UserIdlist, int state) {

            CacheHelper.RemoveContain("User_");
            return dal.DeleteFlagList(F_UserIdlist,state);
        }


        /// <summary>
        /// 得到一个对象实体
        /// </summary>
        public Model.T_Sys_UserAccount GetModel(int F_UserId)
        {
            return dal.GetModel(F_UserId);
        }

        /// <summary>
        /// 得到一个对象实体
        /// </summary>
        public Model.T_Sys_UserAccount GetModel(string F_UserCode)
        {

            var user=CacheHelper.Get<Model.T_Sys_UserAccount>("User_"+F_UserCode);
            if (user != null)
            {
                var rolecode = new Bll.T_Sys_Role().GetModel((int)user.F_RoleId)?.F_RoleCode ?? "";
                var deptcode = new Bll.T_Sys_Department().GetModel((int)user.F_DeptId)?.F_DeptCode ?? "";
                user.F_RoleCode = rolecode;
                user.F_DeptCode = deptcode;
                return user;
            }
            else
            {
                var user1 = dal.GetModel(F_UserCode);
                if (user1 != null)
                {
                    var rolecode = new Bll.T_Sys_Role().GetModel((int)user1.F_RoleId)?.F_RoleCode ?? "";
                    var deptcode = new Bll.T_Sys_Department().GetModel((int)user1.F_DeptId)?.F_DeptCode ?? "";
                    user1.F_RoleCode = rolecode;
                    user1.F_DeptCode = deptcode;
                    CacheHelper.Insert(F_UserCode, user1, 10);
                    return user1;
                }
                else return null;
            }
        }

        /// <summary>
        /// 获得数据列表
        /// </summary>
        public DataSet GetList(string strWhere)
        {
            return dal.GetList(strWhere);
        }
        /// <summary>
        /// 获得前几行数据
        /// </summary>
        public DataSet GetList(int Top, string strWhere, string filedOrder)
        {
            return dal.GetList(Top, strWhere, filedOrder);
        }
        /// <summary>
        /// 获得数据列表
        /// </summary>
        public List<Model.T_Sys_UserAccount> GetModelList(string strWhere)
        {
            DataSet ds = dal.GetList(strWhere);
            return DataTableToList(ds.Tables[0]);
        }
        /// <summary>
        /// 获得数据列表
        /// </summary>
        public List<Model.T_Sys_UserAccount> DataTableToList(DataTable dt)
        {
            List<Model.T_Sys_UserAccount> modelList = new List<Model.T_Sys_UserAccount>();
            int rowsCount = dt.Rows.Count;
            if (rowsCount > 0)
            {
                Model.T_Sys_UserAccount model;
                for (int n = 0; n < rowsCount; n++)
                {
                    model = dal.DataRowToModel(dt.Rows[n]);
                    if (model != null)
                    {
                        modelList.Add(model);
                    }
                }
            }
            return modelList;
        }

        /// <summary>
        /// 获得数据列表
        /// </summary>
        public DataSet GetAllList()
        {
            return GetList("");
        }

        /// <summary>
        /// 分页获取数据列表
        /// </summary>
        public int GetRecordCount(string strWhere)
        {
            return dal.GetRecordCount(strWhere);
        }

        #endregion  BasicMethod
    }
}

